﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TreeComboBoxDemo.Model
{
    /// <summary>
    /// 警报步骤
    /// </summary>
    public class M_Step : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null) this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

        #region 步骤Id
        private byte _StepID = default(byte);
        public byte StepID
        {
            get { return _StepID; }
            set
            {
                if (_StepID != value)
                {
                    _StepID = value;
                    this.RaisePropertyChanged("StepID");
                }
            }
        }
        #endregion

        #region 步骤名称
        private string _StepName = default(string);
        public string StepName
        {
            get { return _StepName; }
            set
            {
                if (_StepName != value)
                {
                    _StepName = value;
                    this.RaisePropertyChanged("StepName");
                }
            }
        }
        #endregion

        #region 步骤描述
        private string _Description = default(string);
        public string Description
        {
            get { return _Description; }
            set
            {
                if (_Description != value)
                {
                    _Description = value;
                    this.RaisePropertyChanged("Description");
                }
            }
        }
        #endregion
    }

    class TreeItemModel<T> : INotifyPropertyChanged where T : class
    {
        #region INotifyPropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null) this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

        #region 数据
        private T _Data = default(T);
        public T Data
        {
            get { return _Data; }
            set
            {
                if (_Data != value)
                {
                    _Data = value;
                    this.RaisePropertyChanged("Data");
                }
            }
        }
        #endregion

        #region 拥有的子项
        private ObservableCollection<TreeItemModel<T>> _Childeren = default(ObservableCollection<TreeItemModel<T>>);
        public ObservableCollection<TreeItemModel<T>> Childeren
        {
            get { return _Childeren; }
            set
            {
                if (_Childeren != value)
                {
                    _Childeren = value;
                    this.RaisePropertyChanged("Childeren");
                }
            }
        }
        #endregion
    }
}
